#!/bin/bash

GPSMODULE="quectel"
GPSPORT=/dev/ttyUSB1
ATPORT=/dev/ttyUSB2
ACK=/at_ack
LogFile3=/var/log/gps/GPSTest-CheckModule.log

function detectModule(){
	if [ -e $GPSPORT ]; then
		stopGPS >>  $1
		sleep 1
		startGPS >>  $1
		cat $GPSPORT | while read -r line; do
			NMEAHead=`echo $line | awk -F "," '{print $1}'`
			echo "$line" >>  $1
			if [[ $NMEAHead == '$GPRMC' ]]; then
				break
			fi
		done
		if  ! OUTPUT=$(cat $1 | grep GPRMC > /dev/null); then
			return 0
		else 
			return 1
		fi
	else
		echo "Error: $GPSPORT is not exist"
		return 0
	fi
}

function startGPS(){
	echo "start $GPSMODULE GPS"
	send_at_command "at+qgps=1"
	read_at_result "at+qgps=1"
	if [[ $at_result == *"OK"* ]]; then
		echo "start quectel GPS success"
	else
		stopGPS
		sleep 1
		startGPS
	fi
}

function stopGPS(){
	echo "stop $GPSMODULE GPS"
	send_at_command "at+qgpsend"
	read_at_result "at+qgpsend"
	if [[ $at_result == *"OK"* ]]; then
		echo "stop quectel GPS success"
	fi
}

function send_at_command() {
	echo "send_at_command ${1}"
    if [ -e ${ATPORT} ]; then
        echo -ne "${1}\r" | busybox microcom -t 3000 ${ATPORT} > ${ACK}
    else
        echo "ERROR device not found" > ${ACK}
    fi
}

function read_at_result() {
    at_result=`cat ${ACK} | tr -d '\r'`
	echo "read_at_result ${at_result}"
    if [[ $at_result == *"ERROR"* ]]; then
		echo ${at_result##*${1}}
        at_result="FAIL"
    else
        at_result=`echo ${at_result##*${1}}`
    fi
}

rm $LogFile3
echo "$DATE detectModule: $GPSMODULE" >> $LogFile3
detectModule $LogFile3
retval=$?
if [ "$retval" == 1 ]; then
	echo "PASS" | tee -a $LogFile3
else
	echo "FAIL" | tee -a $LogFile3
fi
